// Auto-generated. Do not edit!

// (in-package arm_navigation_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let CollisionObjectOperation = require('./CollisionObjectOperation.js');
let Shape = require('./Shape.js');
let geometry_msgs = _finder('geometry_msgs');
let std_msgs = _finder('std_msgs');

//-----------------------------------------------------------

class CollisionObject {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.header = null;
      this.id = null;
      this.padding = null;
      this.operation = null;
      this.shapes = null;
      this.poses = null;
    }
    else {
      if (initObj.hasOwnProperty('header')) {
        this.header = initObj.header
      }
      else {
        this.header = new std_msgs.msg.Header();
      }
      if (initObj.hasOwnProperty('id')) {
        this.id = initObj.id
      }
      else {
        this.id = '';
      }
      if (initObj.hasOwnProperty('padding')) {
        this.padding = initObj.padding
      }
      else {
        this.padding = 0.0;
      }
      if (initObj.hasOwnProperty('operation')) {
        this.operation = initObj.operation
      }
      else {
        this.operation = new CollisionObjectOperation();
      }
      if (initObj.hasOwnProperty('shapes')) {
        this.shapes = initObj.shapes
      }
      else {
        this.shapes = [];
      }
      if (initObj.hasOwnProperty('poses')) {
        this.poses = initObj.poses
      }
      else {
        this.poses = [];
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type CollisionObject
    // Serialize message field [header]
    bufferOffset = std_msgs.msg.Header.serialize(obj.header, buffer, bufferOffset);
    // Serialize message field [id]
    bufferOffset = _serializer.string(obj.id, buffer, bufferOffset);
    // Serialize message field [padding]
    bufferOffset = _serializer.float32(obj.padding, buffer, bufferOffset);
    // Serialize message field [operation]
    bufferOffset = CollisionObjectOperation.serialize(obj.operation, buffer, bufferOffset);
    // Serialize message field [shapes]
    // Serialize the length for message field [shapes]
    bufferOffset = _serializer.uint32(obj.shapes.length, buffer, bufferOffset);
    obj.shapes.forEach((val) => {
      bufferOffset = Shape.serialize(val, buffer, bufferOffset);
    });
    // Serialize message field [poses]
    // Serialize the length for message field [poses]
    bufferOffset = _serializer.uint32(obj.poses.length, buffer, bufferOffset);
    obj.poses.forEach((val) => {
      bufferOffset = geometry_msgs.msg.Pose.serialize(val, buffer, bufferOffset);
    });
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type CollisionObject
    let len;
    let data = new CollisionObject(null);
    // Deserialize message field [header]
    data.header = std_msgs.msg.Header.deserialize(buffer, bufferOffset);
    // Deserialize message field [id]
    data.id = _deserializer.string(buffer, bufferOffset);
    // Deserialize message field [padding]
    data.padding = _deserializer.float32(buffer, bufferOffset);
    // Deserialize message field [operation]
    data.operation = CollisionObjectOperation.deserialize(buffer, bufferOffset);
    // Deserialize message field [shapes]
    // Deserialize array length for message field [shapes]
    len = _deserializer.uint32(buffer, bufferOffset);
    data.shapes = new Array(len);
    for (let i = 0; i < len; ++i) {
      data.shapes[i] = Shape.deserialize(buffer, bufferOffset)
    }
    // Deserialize message field [poses]
    // Deserialize array length for message field [poses]
    len = _deserializer.uint32(buffer, bufferOffset);
    data.poses = new Array(len);
    for (let i = 0; i < len; ++i) {
      data.poses[i] = geometry_msgs.msg.Pose.deserialize(buffer, bufferOffset)
    }
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += std_msgs.msg.Header.getMessageSize(object.header);
    length += object.id.length;
    object.shapes.forEach((val) => {
      length += Shape.getMessageSize(val);
    });
    length += 56 * object.poses.length;
    return length + 17;
  }

  static datatype() {
    // Returns string type for a message object
    return 'arm_navigation_msgs/CollisionObject';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '7b972910c23ece1b873b3de0cf92ba97';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # a header, used for interpreting the poses
    Header header
    
    # the id of the object
    string id
    
    # The padding used for filtering points near the object.
    # This does not affect collision checking for the object.  
    # Set to negative to get zero padding.
    float32 padding
    
    #This contains what is to be done with the object
    CollisionObjectOperation operation
    
    #the shapes associated with the object
    arm_navigation_msgs/Shape[] shapes
    
    #the poses associated with the shapes - will be transformed using the header
    geometry_msgs/Pose[] poses
    
    ================================================================================
    MSG: std_msgs/Header
    # Standard metadata for higher-level stamped data types.
    # This is generally used to communicate timestamped data 
    # in a particular coordinate frame.
    # 
    # sequence ID: consecutively increasing ID 
    uint32 seq
    #Two-integer timestamp that is expressed as:
    # * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
    # * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
    # time-handling sugar is provided by the client library
    time stamp
    #Frame this data is associated with
    # 0: no frame
    # 1: global frame
    string frame_id
    
    ================================================================================
    MSG: arm_navigation_msgs/CollisionObjectOperation
    #Puts the object into the environment
    #or updates the object if already added
    byte ADD=0
    
    #Removes the object from the environment entirely
    byte REMOVE=1
    
    #Only valid within the context of a CollisionAttachedObject message
    #Will be ignored if sent with an CollisionObject message
    #Takes an attached object, detaches from the attached link
    #But adds back in as regular object
    byte DETACH_AND_ADD_AS_OBJECT=2
    
    #Only valid within the context of a CollisionAttachedObject message
    #Will be ignored if sent with an CollisionObject message
    #Takes current object in the environment and removes it as
    #a regular object
    byte ATTACH_AND_REMOVE_AS_OBJECT=3
    
    # Byte code for operation
    byte operation
    
    ================================================================================
    MSG: arm_navigation_msgs/Shape
    byte SPHERE=0
    byte BOX=1
    byte CYLINDER=2
    byte MESH=3
    
    byte type
    
    
    #### define sphere, box, cylinder ####
    # the origin of each shape is considered at the shape's center
    
    # for sphere
    # radius := dimensions[0]
    
    # for cylinder
    # radius := dimensions[0]
    # length := dimensions[1]
    # the length is along the Z axis
    
    # for box
    # size_x := dimensions[0]
    # size_y := dimensions[1]
    # size_z := dimensions[2]
    float64[] dimensions
    
    
    #### define mesh ####
    
    # list of triangles; triangle k is defined by tre vertices located
    # at indices triangles[3k], triangles[3k+1], triangles[3k+2]
    int32[] triangles
    geometry_msgs/Point[] vertices
    
    ================================================================================
    MSG: geometry_msgs/Point
    # This contains the position of a point in free space
    float64 x
    float64 y
    float64 z
    
    ================================================================================
    MSG: geometry_msgs/Pose
    # A representation of pose in free space, composed of position and orientation. 
    Point position
    Quaternion orientation
    
    ================================================================================
    MSG: geometry_msgs/Quaternion
    # This represents an orientation in free space in quaternion form.
    
    float64 x
    float64 y
    float64 z
    float64 w
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new CollisionObject(null);
    if (msg.header !== undefined) {
      resolved.header = std_msgs.msg.Header.Resolve(msg.header)
    }
    else {
      resolved.header = new std_msgs.msg.Header()
    }

    if (msg.id !== undefined) {
      resolved.id = msg.id;
    }
    else {
      resolved.id = ''
    }

    if (msg.padding !== undefined) {
      resolved.padding = msg.padding;
    }
    else {
      resolved.padding = 0.0
    }

    if (msg.operation !== undefined) {
      resolved.operation = CollisionObjectOperation.Resolve(msg.operation)
    }
    else {
      resolved.operation = new CollisionObjectOperation()
    }

    if (msg.shapes !== undefined) {
      resolved.shapes = new Array(msg.shapes.length);
      for (let i = 0; i < resolved.shapes.length; ++i) {
        resolved.shapes[i] = Shape.Resolve(msg.shapes[i]);
      }
    }
    else {
      resolved.shapes = []
    }

    if (msg.poses !== undefined) {
      resolved.poses = new Array(msg.poses.length);
      for (let i = 0; i < resolved.poses.length; ++i) {
        resolved.poses[i] = geometry_msgs.msg.Pose.Resolve(msg.poses[i]);
      }
    }
    else {
      resolved.poses = []
    }

    return resolved;
    }
};

module.exports = CollisionObject;
