// Auto-generated. Do not edit!

// (in-package arm_navigation_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;

//-----------------------------------------------------------

class CollisionOperation {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.object1 = null;
      this.object2 = null;
      this.penetration_distance = null;
      this.operation = null;
    }
    else {
      if (initObj.hasOwnProperty('object1')) {
        this.object1 = initObj.object1
      }
      else {
        this.object1 = '';
      }
      if (initObj.hasOwnProperty('object2')) {
        this.object2 = initObj.object2
      }
      else {
        this.object2 = '';
      }
      if (initObj.hasOwnProperty('penetration_distance')) {
        this.penetration_distance = initObj.penetration_distance
      }
      else {
        this.penetration_distance = 0.0;
      }
      if (initObj.hasOwnProperty('operation')) {
        this.operation = initObj.operation
      }
      else {
        this.operation = 0;
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type CollisionOperation
    // Serialize message field [object1]
    bufferOffset = _serializer.string(obj.object1, buffer, bufferOffset);
    // Serialize message field [object2]
    bufferOffset = _serializer.string(obj.object2, buffer, bufferOffset);
    // Serialize message field [penetration_distance]
    bufferOffset = _serializer.float64(obj.penetration_distance, buffer, bufferOffset);
    // Serialize message field [operation]
    bufferOffset = _serializer.int32(obj.operation, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type CollisionOperation
    let len;
    let data = new CollisionOperation(null);
    // Deserialize message field [object1]
    data.object1 = _deserializer.string(buffer, bufferOffset);
    // Deserialize message field [object2]
    data.object2 = _deserializer.string(buffer, bufferOffset);
    // Deserialize message field [penetration_distance]
    data.penetration_distance = _deserializer.float64(buffer, bufferOffset);
    // Deserialize message field [operation]
    data.operation = _deserializer.int32(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += object.object1.length;
    length += object.object2.length;
    return length + 20;
  }

  static datatype() {
    // Returns string type for a message object
    return 'arm_navigation_msgs/CollisionOperation';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return 'e0cf3073b26bd86266c918a0c779f8a2';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # A definition of a collision operation
    # E.g. ("gripper",COLLISION_SET_ALL,ENABLE) will enable collisions 
    # between the gripper and all objects in the collision space
    
    string object1
    string object2
    string COLLISION_SET_ALL="all"
    string COLLISION_SET_OBJECTS="objects"
    string COLLISION_SET_ATTACHED_OBJECTS="attached"
    
    # The penetration distance to which collisions are allowed. This is 0.0 by default.
    float64 penetration_distance
    
    # Flag that determines whether collisions will be enabled or disabled for the pair of objects specified above
    int32 operation
    int32 DISABLE=0
    int32 ENABLE=1
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new CollisionOperation(null);
    if (msg.object1 !== undefined) {
      resolved.object1 = msg.object1;
    }
    else {
      resolved.object1 = ''
    }

    if (msg.object2 !== undefined) {
      resolved.object2 = msg.object2;
    }
    else {
      resolved.object2 = ''
    }

    if (msg.penetration_distance !== undefined) {
      resolved.penetration_distance = msg.penetration_distance;
    }
    else {
      resolved.penetration_distance = 0.0
    }

    if (msg.operation !== undefined) {
      resolved.operation = msg.operation;
    }
    else {
      resolved.operation = 0
    }

    return resolved;
    }
};

// Constants for message
CollisionOperation.Constants = {
  COLLISION_SET_ALL: '"all"',
  COLLISION_SET_OBJECTS: '"objects"',
  COLLISION_SET_ATTACHED_OBJECTS: '"attached"',
  DISABLE: 0,
  ENABLE: 1,
}

module.exports = CollisionOperation;
