// Auto-generated. Do not edit!

// (in-package arm_navigation_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let CollisionOperation = require('./CollisionOperation.js');

//-----------------------------------------------------------

class OrderedCollisionOperations {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.collision_operations = null;
    }
    else {
      if (initObj.hasOwnProperty('collision_operations')) {
        this.collision_operations = initObj.collision_operations
      }
      else {
        this.collision_operations = [];
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type OrderedCollisionOperations
    // Serialize message field [collision_operations]
    // Serialize the length for message field [collision_operations]
    bufferOffset = _serializer.uint32(obj.collision_operations.length, buffer, bufferOffset);
    obj.collision_operations.forEach((val) => {
      bufferOffset = CollisionOperation.serialize(val, buffer, bufferOffset);
    });
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type OrderedCollisionOperations
    let len;
    let data = new OrderedCollisionOperations(null);
    // Deserialize message field [collision_operations]
    // Deserialize array length for message field [collision_operations]
    len = _deserializer.uint32(buffer, bufferOffset);
    data.collision_operations = new Array(len);
    for (let i = 0; i < len; ++i) {
      data.collision_operations[i] = CollisionOperation.deserialize(buffer, bufferOffset)
    }
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    object.collision_operations.forEach((val) => {
      length += CollisionOperation.getMessageSize(val);
    });
    return length + 4;
  }

  static datatype() {
    // Returns string type for a message object
    return 'arm_navigation_msgs/OrderedCollisionOperations';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return 'f171f973b185d4d0121795080114026a';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # A set of collision operations that will be performed in the order they are specified
    CollisionOperation[] collision_operations
    ================================================================================
    MSG: arm_navigation_msgs/CollisionOperation
    # A definition of a collision operation
    # E.g. ("gripper",COLLISION_SET_ALL,ENABLE) will enable collisions 
    # between the gripper and all objects in the collision space
    
    string object1
    string object2
    string COLLISION_SET_ALL="all"
    string COLLISION_SET_OBJECTS="objects"
    string COLLISION_SET_ATTACHED_OBJECTS="attached"
    
    # The penetration distance to which collisions are allowed. This is 0.0 by default.
    float64 penetration_distance
    
    # Flag that determines whether collisions will be enabled or disabled for the pair of objects specified above
    int32 operation
    int32 DISABLE=0
    int32 ENABLE=1
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new OrderedCollisionOperations(null);
    if (msg.collision_operations !== undefined) {
      resolved.collision_operations = new Array(msg.collision_operations.length);
      for (let i = 0; i < resolved.collision_operations.length; ++i) {
        resolved.collision_operations[i] = CollisionOperation.Resolve(msg.collision_operations[i]);
      }
    }
    else {
      resolved.collision_operations = []
    }

    return resolved;
    }
};

module.exports = OrderedCollisionOperations;
