// Auto-generated. Do not edit!

// (in-package arm_navigation_msgs.srv)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let MotionPlanRequest = require('../msg/MotionPlanRequest.js');

//-----------------------------------------------------------

let RobotTrajectory = require('../msg/RobotTrajectory.js');
let RobotState = require('../msg/RobotState.js');
let ArmNavigationErrorCodes = require('../msg/ArmNavigationErrorCodes.js');

//-----------------------------------------------------------

class GetMotionPlanRequest {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.motion_plan_request = null;
    }
    else {
      if (initObj.hasOwnProperty('motion_plan_request')) {
        this.motion_plan_request = initObj.motion_plan_request
      }
      else {
        this.motion_plan_request = new MotionPlanRequest();
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type GetMotionPlanRequest
    // Serialize message field [motion_plan_request]
    bufferOffset = MotionPlanRequest.serialize(obj.motion_plan_request, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type GetMotionPlanRequest
    let len;
    let data = new GetMotionPlanRequest(null);
    // Deserialize message field [motion_plan_request]
    data.motion_plan_request = MotionPlanRequest.deserialize(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += MotionPlanRequest.getMessageSize(object.motion_plan_request);
    return length;
  }

  static datatype() {
    // Returns string type for a service object
    return 'arm_navigation_msgs/GetMotionPlanRequest';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '53194db8d1959c06cb41e066f1f6695e';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    
    
    
    MotionPlanRequest motion_plan_request
    
    
    ================================================================================
    MSG: arm_navigation_msgs/MotionPlanRequest
    # This service contains the definition for a request to the motion
    # planner and the output it provides
    
    # Parameters for the workspace that the planner should work inside
    arm_navigation_msgs/WorkspaceParameters workspace_parameters
    
    # Starting state updates. If certain joints should be considered
    # at positions other than the current ones, these positions should
    # be set here
    arm_navigation_msgs/RobotState start_state
    
    # The goal state for the model to plan for. The goal is achieved
    # if all constraints are satisfied
    arm_navigation_msgs/Constraints goal_constraints
    
    # No state at any point along the path in the produced motion plan will violate these constraints
    arm_navigation_msgs/Constraints path_constraints
    
    # The name of the motion planner to use. If no name is specified,
    # a default motion planner will be used
    string planner_id
    
    # The name of the group of joints on which this planner is operating
    string group_name
    
    # The number of times this plan is to be computed. Shortest solution
    # will be reported.
    int32 num_planning_attempts
    
    # The maximum amount of time the motion planner is allowed to plan for
    duration allowed_planning_time
    
    # An expected path duration (in seconds) along with an expected discretization of the path allows the planner to determine the discretization of the trajectory that it returns
    duration expected_path_duration
    duration expected_path_dt
    
    ================================================================================
    MSG: arm_navigation_msgs/WorkspaceParameters
    # This message contains a set of parameters useful in
    # setting up the workspace for planning
    arm_navigation_msgs/Shape  workspace_region_shape
    geometry_msgs/PoseStamped    workspace_region_pose
    
    
    ================================================================================
    MSG: arm_navigation_msgs/Shape
    byte SPHERE=0
    byte BOX=1
    byte CYLINDER=2
    byte MESH=3
    
    byte type
    
    
    #### define sphere, box, cylinder ####
    # the origin of each shape is considered at the shape's center
    
    # for sphere
    # radius := dimensions[0]
    
    # for cylinder
    # radius := dimensions[0]
    # length := dimensions[1]
    # the length is along the Z axis
    
    # for box
    # size_x := dimensions[0]
    # size_y := dimensions[1]
    # size_z := dimensions[2]
    float64[] dimensions
    
    
    #### define mesh ####
    
    # list of triangles; triangle k is defined by tre vertices located
    # at indices triangles[3k], triangles[3k+1], triangles[3k+2]
    int32[] triangles
    geometry_msgs/Point[] vertices
    
    ================================================================================
    MSG: geometry_msgs/Point
    # This contains the position of a point in free space
    float64 x
    float64 y
    float64 z
    
    ================================================================================
    MSG: geometry_msgs/PoseStamped
    # A Pose with reference coordinate frame and timestamp
    Header header
    Pose pose
    
    ================================================================================
    MSG: std_msgs/Header
    # Standard metadata for higher-level stamped data types.
    # This is generally used to communicate timestamped data 
    # in a particular coordinate frame.
    # 
    # sequence ID: consecutively increasing ID 
    uint32 seq
    #Two-integer timestamp that is expressed as:
    # * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
    # * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
    # time-handling sugar is provided by the client library
    time stamp
    #Frame this data is associated with
    # 0: no frame
    # 1: global frame
    string frame_id
    
    ================================================================================
    MSG: geometry_msgs/Pose
    # A representation of pose in free space, composed of position and orientation. 
    Point position
    Quaternion orientation
    
    ================================================================================
    MSG: geometry_msgs/Quaternion
    # This represents an orientation in free space in quaternion form.
    
    float64 x
    float64 y
    float64 z
    float64 w
    
    ================================================================================
    MSG: arm_navigation_msgs/RobotState
    # This message contains information about the robot state, i.e. the positions of its joints and links
    sensor_msgs/JointState joint_state
    arm_navigation_msgs/MultiDOFJointState multi_dof_joint_state
    
    ================================================================================
    MSG: sensor_msgs/JointState
    # This is a message that holds data to describe the state of a set of torque controlled joints. 
    #
    # The state of each joint (revolute or prismatic) is defined by:
    #  * the position of the joint (rad or m),
    #  * the velocity of the joint (rad/s or m/s) and 
    #  * the effort that is applied in the joint (Nm or N).
    #
    # Each joint is uniquely identified by its name
    # The header specifies the time at which the joint states were recorded. All the joint states
    # in one message have to be recorded at the same time.
    #
    # This message consists of a multiple arrays, one for each part of the joint state. 
    # The goal is to make each of the fields optional. When e.g. your joints have no
    # effort associated with them, you can leave the effort array empty. 
    #
    # All arrays in this message should have the same size, or be empty.
    # This is the only way to uniquely associate the joint name with the correct
    # states.
    
    
    Header header
    
    string[] name
    float64[] position
    float64[] velocity
    float64[] effort
    
    ================================================================================
    MSG: arm_navigation_msgs/MultiDOFJointState
    #A representation of a multi-dof joint state
    time stamp
    string[] joint_names
    string[] frame_ids
    string[] child_frame_ids
    geometry_msgs/Pose[] poses
    
    ================================================================================
    MSG: arm_navigation_msgs/Constraints
    # This message contains a list of motion planning constraints.
    
    arm_navigation_msgs/JointConstraint[] joint_constraints
    arm_navigation_msgs/PositionConstraint[] position_constraints
    arm_navigation_msgs/OrientationConstraint[] orientation_constraints
    arm_navigation_msgs/VisibilityConstraint[] visibility_constraints
    
    ================================================================================
    MSG: arm_navigation_msgs/JointConstraint
    # Constrain the position of a joint to be within a certain bound
    string joint_name
    
    # the bound to be achieved is [position - tolerance_below, position + tolerance_above]
    float64 position
    float64 tolerance_above
    float64 tolerance_below
    
    # A weighting factor for this constraint
    float64 weight
    ================================================================================
    MSG: arm_navigation_msgs/PositionConstraint
    # This message contains the definition of a position constraint.
    Header header
    
    # The robot link this constraint refers to
    string link_name
    
    # The offset (in the link frame) for the target point on the link we are planning for
    geometry_msgs/Point target_point_offset
    
    # The nominal/target position for the point we are planning for
    geometry_msgs/Point position
    
    # The shape of the bounded region that constrains the position of the end-effector
    # This region is always centered at the position defined above
    arm_navigation_msgs/Shape constraint_region_shape
    
    # The orientation of the bounded region that constrains the position of the end-effector. 
    # This allows the specification of non-axis aligned constraints
    geometry_msgs/Quaternion constraint_region_orientation
    
    # Constraint weighting factor - a weight for this constraint
    float64 weight
    
    ================================================================================
    MSG: arm_navigation_msgs/OrientationConstraint
    # This message contains the definition of an orientation constraint.
    Header header
    
    # The robot link this constraint refers to
    string link_name
    
    # The type of the constraint
    int32 type
    int32 LINK_FRAME=0
    int32 HEADER_FRAME=1
    
    # The desired orientation of the robot link specified as a quaternion
    geometry_msgs/Quaternion orientation
    
    # optional RPY error tolerances specified if 
    float64 absolute_roll_tolerance
    float64 absolute_pitch_tolerance
    float64 absolute_yaw_tolerance
    
    # Constraint weighting factor - a weight for this constraint
    float64 weight
    
    ================================================================================
    MSG: arm_navigation_msgs/VisibilityConstraint
    # This message contains the definition of a visibility constraint.
    Header header
    
    # The point stamped target that needs to be kept within view of the sensor
    geometry_msgs/PointStamped target
    
    # The local pose of the frame in which visibility is to be maintained
    # The frame id should represent the robot link to which the sensor is attached
    # The visual axis of the sensor is assumed to be along the X axis of this frame
    geometry_msgs/PoseStamped sensor_pose
    
    # The deviation (in radians) that will be tolerated
    # Constraint error will be measured as the solid angle between the 
    # X axis of the frame defined above and the vector between the origin 
    # of the frame defined above and the target location
    float64 absolute_tolerance
    
    
    ================================================================================
    MSG: geometry_msgs/PointStamped
    # This represents a Point with reference coordinate frame and timestamp
    Header header
    Point point
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new GetMotionPlanRequest(null);
    if (msg.motion_plan_request !== undefined) {
      resolved.motion_plan_request = MotionPlanRequest.Resolve(msg.motion_plan_request)
    }
    else {
      resolved.motion_plan_request = new MotionPlanRequest()
    }

    return resolved;
    }
};

class GetMotionPlanResponse {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.trajectory = null;
      this.robot_state = null;
      this.planning_time = null;
      this.error_code = null;
      this.trajectory_error_codes = null;
    }
    else {
      if (initObj.hasOwnProperty('trajectory')) {
        this.trajectory = initObj.trajectory
      }
      else {
        this.trajectory = new RobotTrajectory();
      }
      if (initObj.hasOwnProperty('robot_state')) {
        this.robot_state = initObj.robot_state
      }
      else {
        this.robot_state = new RobotState();
      }
      if (initObj.hasOwnProperty('planning_time')) {
        this.planning_time = initObj.planning_time
      }
      else {
        this.planning_time = {secs: 0, nsecs: 0};
      }
      if (initObj.hasOwnProperty('error_code')) {
        this.error_code = initObj.error_code
      }
      else {
        this.error_code = new ArmNavigationErrorCodes();
      }
      if (initObj.hasOwnProperty('trajectory_error_codes')) {
        this.trajectory_error_codes = initObj.trajectory_error_codes
      }
      else {
        this.trajectory_error_codes = [];
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type GetMotionPlanResponse
    // Serialize message field [trajectory]
    bufferOffset = RobotTrajectory.serialize(obj.trajectory, buffer, bufferOffset);
    // Serialize message field [robot_state]
    bufferOffset = RobotState.serialize(obj.robot_state, buffer, bufferOffset);
    // Serialize message field [planning_time]
    bufferOffset = _serializer.duration(obj.planning_time, buffer, bufferOffset);
    // Serialize message field [error_code]
    bufferOffset = ArmNavigationErrorCodes.serialize(obj.error_code, buffer, bufferOffset);
    // Serialize message field [trajectory_error_codes]
    // Serialize the length for message field [trajectory_error_codes]
    bufferOffset = _serializer.uint32(obj.trajectory_error_codes.length, buffer, bufferOffset);
    obj.trajectory_error_codes.forEach((val) => {
      bufferOffset = ArmNavigationErrorCodes.serialize(val, buffer, bufferOffset);
    });
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type GetMotionPlanResponse
    let len;
    let data = new GetMotionPlanResponse(null);
    // Deserialize message field [trajectory]
    data.trajectory = RobotTrajectory.deserialize(buffer, bufferOffset);
    // Deserialize message field [robot_state]
    data.robot_state = RobotState.deserialize(buffer, bufferOffset);
    // Deserialize message field [planning_time]
    data.planning_time = _deserializer.duration(buffer, bufferOffset);
    // Deserialize message field [error_code]
    data.error_code = ArmNavigationErrorCodes.deserialize(buffer, bufferOffset);
    // Deserialize message field [trajectory_error_codes]
    // Deserialize array length for message field [trajectory_error_codes]
    len = _deserializer.uint32(buffer, bufferOffset);
    data.trajectory_error_codes = new Array(len);
    for (let i = 0; i < len; ++i) {
      data.trajectory_error_codes[i] = ArmNavigationErrorCodes.deserialize(buffer, bufferOffset)
    }
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += RobotTrajectory.getMessageSize(object.trajectory);
    length += RobotState.getMessageSize(object.robot_state);
    length += 4 * object.trajectory_error_codes.length;
    return length + 16;
  }

  static datatype() {
    // Returns string type for a service object
    return 'arm_navigation_msgs/GetMotionPlanResponse';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '85e06df8040608943ed808c52d463218';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    
    
    arm_navigation_msgs/RobotTrajectory trajectory
    
    
    arm_navigation_msgs/RobotState robot_state
    
    
    duration planning_time
    
    
    arm_navigation_msgs/ArmNavigationErrorCodes error_code
    
    
    arm_navigation_msgs/ArmNavigationErrorCodes[] trajectory_error_codes
    
    
    ================================================================================
    MSG: arm_navigation_msgs/RobotTrajectory
    trajectory_msgs/JointTrajectory joint_trajectory
    arm_navigation_msgs/MultiDOFJointTrajectory multi_dof_joint_trajectory
    
    ================================================================================
    MSG: trajectory_msgs/JointTrajectory
    Header header
    string[] joint_names
    JointTrajectoryPoint[] points
    ================================================================================
    MSG: std_msgs/Header
    # Standard metadata for higher-level stamped data types.
    # This is generally used to communicate timestamped data 
    # in a particular coordinate frame.
    # 
    # sequence ID: consecutively increasing ID 
    uint32 seq
    #Two-integer timestamp that is expressed as:
    # * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
    # * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
    # time-handling sugar is provided by the client library
    time stamp
    #Frame this data is associated with
    # 0: no frame
    # 1: global frame
    string frame_id
    
    ================================================================================
    MSG: trajectory_msgs/JointTrajectoryPoint
    # Each trajectory point specifies either positions[, velocities[, accelerations]]
    # or positions[, effort] for the trajectory to be executed.
    # All specified values are in the same order as the joint names in JointTrajectory.msg
    
    float64[] positions
    float64[] velocities
    float64[] accelerations
    float64[] effort
    duration time_from_start
    
    ================================================================================
    MSG: arm_navigation_msgs/MultiDOFJointTrajectory
    #A representation of a multi-dof joint trajectory
    duration stamp
    string[] joint_names
    string[] frame_ids
    string[] child_frame_ids
    MultiDOFJointTrajectoryPoint[] points
    
    ================================================================================
    MSG: arm_navigation_msgs/MultiDOFJointTrajectoryPoint
    geometry_msgs/Pose[] poses
    duration time_from_start
    ================================================================================
    MSG: geometry_msgs/Pose
    # A representation of pose in free space, composed of position and orientation. 
    Point position
    Quaternion orientation
    
    ================================================================================
    MSG: geometry_msgs/Point
    # This contains the position of a point in free space
    float64 x
    float64 y
    float64 z
    
    ================================================================================
    MSG: geometry_msgs/Quaternion
    # This represents an orientation in free space in quaternion form.
    
    float64 x
    float64 y
    float64 z
    float64 w
    
    ================================================================================
    MSG: arm_navigation_msgs/RobotState
    # This message contains information about the robot state, i.e. the positions of its joints and links
    sensor_msgs/JointState joint_state
    arm_navigation_msgs/MultiDOFJointState multi_dof_joint_state
    
    ================================================================================
    MSG: sensor_msgs/JointState
    # This is a message that holds data to describe the state of a set of torque controlled joints. 
    #
    # The state of each joint (revolute or prismatic) is defined by:
    #  * the position of the joint (rad or m),
    #  * the velocity of the joint (rad/s or m/s) and 
    #  * the effort that is applied in the joint (Nm or N).
    #
    # Each joint is uniquely identified by its name
    # The header specifies the time at which the joint states were recorded. All the joint states
    # in one message have to be recorded at the same time.
    #
    # This message consists of a multiple arrays, one for each part of the joint state. 
    # The goal is to make each of the fields optional. When e.g. your joints have no
    # effort associated with them, you can leave the effort array empty. 
    #
    # All arrays in this message should have the same size, or be empty.
    # This is the only way to uniquely associate the joint name with the correct
    # states.
    
    
    Header header
    
    string[] name
    float64[] position
    float64[] velocity
    float64[] effort
    
    ================================================================================
    MSG: arm_navigation_msgs/MultiDOFJointState
    #A representation of a multi-dof joint state
    time stamp
    string[] joint_names
    string[] frame_ids
    string[] child_frame_ids
    geometry_msgs/Pose[] poses
    
    ================================================================================
    MSG: arm_navigation_msgs/ArmNavigationErrorCodes
    int32 val
    
    # overall behavior
    int32 PLANNING_FAILED=-1
    int32 SUCCESS=1
    int32 TIMED_OUT=-2
    
    # start state errors
    int32 START_STATE_IN_COLLISION=-3
    int32 START_STATE_VIOLATES_PATH_CONSTRAINTS=-4
    
    # goal errors
    int32 GOAL_IN_COLLISION=-5
    int32 GOAL_VIOLATES_PATH_CONSTRAINTS=-6
    
    # robot state
    int32 INVALID_ROBOT_STATE=-7
    int32 INCOMPLETE_ROBOT_STATE=-8
    
    # planning request errors
    int32 INVALID_PLANNER_ID=-9
    int32 INVALID_NUM_PLANNING_ATTEMPTS=-10
    int32 INVALID_ALLOWED_PLANNING_TIME=-11
    int32 INVALID_GROUP_NAME=-12
    int32 INVALID_GOAL_JOINT_CONSTRAINTS=-13
    int32 INVALID_GOAL_POSITION_CONSTRAINTS=-14
    int32 INVALID_GOAL_ORIENTATION_CONSTRAINTS=-15
    int32 INVALID_PATH_JOINT_CONSTRAINTS=-16
    int32 INVALID_PATH_POSITION_CONSTRAINTS=-17
    int32 INVALID_PATH_ORIENTATION_CONSTRAINTS=-18
    
    # state/trajectory monitor errors
    int32 INVALID_TRAJECTORY=-19
    int32 INVALID_INDEX=-20
    int32 JOINT_LIMITS_VIOLATED=-21
    int32 PATH_CONSTRAINTS_VIOLATED=-22
    int32 COLLISION_CONSTRAINTS_VIOLATED=-23
    int32 GOAL_CONSTRAINTS_VIOLATED=-24
    int32 JOINTS_NOT_MOVING=-25
    int32 TRAJECTORY_CONTROLLER_FAILED=-26
    
    # system errors
    int32 FRAME_TRANSFORM_FAILURE=-27
    int32 COLLISION_CHECKING_UNAVAILABLE=-28
    int32 ROBOT_STATE_STALE=-29
    int32 SENSOR_INFO_STALE=-30
    
    # kinematics errors
    int32 NO_IK_SOLUTION=-31
    int32 INVALID_LINK_NAME=-32
    int32 IK_LINK_IN_COLLISION=-33
    int32 NO_FK_SOLUTION=-34
    int32 KINEMATICS_STATE_IN_COLLISION=-35
    
    # general errors
    int32 INVALID_TIMEOUT=-36
    
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new GetMotionPlanResponse(null);
    if (msg.trajectory !== undefined) {
      resolved.trajectory = RobotTrajectory.Resolve(msg.trajectory)
    }
    else {
      resolved.trajectory = new RobotTrajectory()
    }

    if (msg.robot_state !== undefined) {
      resolved.robot_state = RobotState.Resolve(msg.robot_state)
    }
    else {
      resolved.robot_state = new RobotState()
    }

    if (msg.planning_time !== undefined) {
      resolved.planning_time = msg.planning_time;
    }
    else {
      resolved.planning_time = {secs: 0, nsecs: 0}
    }

    if (msg.error_code !== undefined) {
      resolved.error_code = ArmNavigationErrorCodes.Resolve(msg.error_code)
    }
    else {
      resolved.error_code = new ArmNavigationErrorCodes()
    }

    if (msg.trajectory_error_codes !== undefined) {
      resolved.trajectory_error_codes = new Array(msg.trajectory_error_codes.length);
      for (let i = 0; i < resolved.trajectory_error_codes.length; ++i) {
        resolved.trajectory_error_codes[i] = ArmNavigationErrorCodes.Resolve(msg.trajectory_error_codes[i]);
      }
    }
    else {
      resolved.trajectory_error_codes = []
    }

    return resolved;
    }
};

module.exports = {
  Request: GetMotionPlanRequest,
  Response: GetMotionPlanResponse,
  md5sum() { return 'cc9c3c17d3e66488975555cb88e921b6'; },
  datatype() { return 'arm_navigation_msgs/GetMotionPlan'; }
};
